# 保存提供嘅研究證據

Canonical URL: https://sosoapi.ai/zh-hant/docs/api/research-api-evidence-supply

Contract: sha256:ab393e91e9b7f18a

明確提供團隊筆記文字、標題及可選來源連結，儲存為未核實 team_notes，不能當作操作指令。用戶提供的文字不能冒認平台採集、已核實帳戶來源或逐字稿。

POST /research-api/evidence/supply

## 驗證及權限

- **接受的憑證類型:** user_session, delegated_oauth, personal_access_token

- **委派權限:** agent:research

- **最低工作空間角色:** editor

- **存取範圍:** 已登入用戶及獲授權資源範圍

- **需要所有工作空間同意:** 否

- **會改動狀態:** 是

- **完成依據:** committed Research resource version; no provider action

憑證不能擴大持有人的權限。實際操作仍會檢查工作空間成員資格、資源擁有權、已選工作空間及能力授權。Tool profile 只會改變可見工具，不會授予權限。

## 請求欄位

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "workspace_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "mutation_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "content": {
      "type": "object",
      "properties": {
        "title": {
          "type": "string",
          "minLength": 1,
          "maxLength": 200
        },
        "text": {
          "type": "string",
          "minLength": 1,
          "maxLength": 20000
        },
        "source_url": {
          "anyOf": [
            {
              "type": "string",
              "maxLength": 2048,
              "format": "uri"
            },
            {
              "type": "null"
            }
          ]
        },
        "published_at": {
          "anyOf": [
            {
              "type": "string",
              "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
              "format": "date-time"
            },
            {
              "type": "null"
            }
          ]
        },
        "language": {
          "anyOf": [
            {
              "type": "string",
              "minLength": 1,
              "maxLength": 35
            },
            {
              "type": "null"
            }
          ]
        }
      },
      "required": [
        "title",
        "text",
        "source_url",
        "published_at",
        "language"
      ],
      "additionalProperties": false
    }
  },
  "required": [
    "workspace_id",
    "mutation_id",
    "content"
  ],
  "additionalProperties": false
}
```

## 回應及完成條件

成功 HTTP 狀態碼: 200

HTTP 成功只表示本次操作的回應。背景工作須保留回傳 ID，並讀取同一操作，直至達到文件指定的終態。接受請求、排程成功或客戶端逾時，均不代表已發佈。

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "evidence": {
      "type": "object",
      "properties": {
        "id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "workspace_id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "revision": {
          "type": "integer",
          "exclusiveMinimum": 0,
          "maximum": 9007199254740991
        },
        "title": {
          "anyOf": [
            {
              "type": "string",
              "minLength": 1,
              "maxLength": 200
            },
            {
              "type": "null"
            }
          ]
        },
        "text": {
          "anyOf": [
            {
              "type": "string",
              "maxLength": 30000
            },
            {
              "type": "null"
            }
          ]
        },
        "source_category": {
          "type": "string",
          "enum": [
            "your_accounts",
            "public_posts",
            "team_notes"
          ]
        },
        "platform": {
          "anyOf": [
            {
              "type": "string",
              "enum": [
                "threads",
                "instagram",
                "facebook",
                "youtube",
                "x",
                "reddit",
                "web"
              ]
            },
            {
              "type": "null"
            }
          ]
        },
        "source_url": {
          "anyOf": [
            {
              "type": "string",
              "maxLength": 2048,
              "format": "uri"
            },
            {
              "type": "null"
            }
          ]
        },
        "author": {
          "anyOf": [
            {
              "type": "string",
              "maxLength": 200
            },
            {
              "type": "null"
            }
          ]
        },
        "language": {
          "anyOf": [
            {
              "type": "string",
              "minLength": 1,
              "maxLength": 35
            },
            {
              "type": "null"
            }
          ]
        },
        "published_at": {
          "anyOf": [
            {
              "type": "string",
              "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
              "format": "date-time"
            },
            {
              "type": "null"
            }
          ]
        },
        "retrieved_at": {
          "type": "string",
          "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
          "format": "date-time"
        },
        "valid_until": {
          "anyOf": [
            {
              "type": "string",
              "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
              "format": "date-time"
            },
            {
              "type": "null"
            }
          ]
        },
        "availability": {
          "type": "string",
          "enum": [
            "available",
            "removed",
            "unavailable"
          ]
        },
        "metrics": {
          "type": "object",
          "properties": {
            "likes": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 0,
                  "maximum": 9007199254740991
                },
                {
                  "type": "null"
                }
              ]
            },
            "replies": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 0,
                  "maximum": 9007199254740991
                },
                {
                  "type": "null"
                }
              ]
            },
            "reposts": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 0,
                  "maximum": 9007199254740991
                },
                {
                  "type": "null"
                }
              ]
            },
            "views": {
              "anyOf": [
                {
                  "type": "integer",
                  "minimum": 0,
                  "maximum": 9007199254740991
                },
                {
                  "type": "null"
                }
              ]
            }
          },
          "required": [
            "likes",
            "replies",
            "reposts",
            "views"
          ]
        }
      },
      "required": [
        "id",
        "workspace_id",
        "revision",
        "title",
        "text",
        "source_category",
        "platform",
        "source_url",
        "author",
        "language",
        "published_at",
        "retrieved_at",
        "valid_until",
        "availability",
        "metrics"
      ]
    }
  },
  "required": [
    "evidence"
  ]
}
```

## 錯誤及安全重試

請檢查 HTTP 狀態及實際回應格式。400 驗證錯誤可能回傳 ZodError；handler 錯誤可能採用 error／message／code envelope。請保留可用的 request_id 或 x-request-id，避免記錄憑證。遇到 401／403 時，須先修正存取問題；429 須遵守 Retry-After。寫入結果未明或回傳 5xx 時，請先讀取原有結果，再決定是否重試。只有操作支援時才可重用 idempotency key；並無通用重試或 exactly-once 保證。

## 範例

以下虛構值已按 contract 驗證，並非真實帳戶 ID、憑證或發佈紀錄。請以已授權範圍回傳的 ID、已準備完成的素材及已審核排程取代，並在寫入前核對平台資格。此頁不會呼叫 API。

在伺服器環境設定 SOSOAPI_ACCESS_TOKEN，使用此操作接受的憑證。請勿將憑證放入瀏覽器程式。一般 AI Agent 建議透過 sosoapi auth login 使用瀏覽器 OAuth，由 CLI 管理憑證更新。

request.json

```json
{
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "11111111-1111-4111-8111-111111111111",
  "content": {
    "title": "example",
    "text": "example",
    "source_url": null,
    "published_at": null,
    "language": null
  }
}
```

cURL

```bash
curl --request POST \
  "https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/evidence/supply" \
  -H "Authorization: Bearer $SOSOAPI_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  --data-binary @request.json
```

JavaScript

```js
// Server-side JavaScript. Do not print tokens or credential-bearing responses.
const token = process.env.SOSOAPI_ACCESS_TOKEN;
if (!token) throw new Error("Set an accepted credential for this operation");
const response = await fetch("https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/evidence/supply", {
  method: "POST",
  headers: { "Content-Type": "application/json", Authorization: "Bearer " + token },
  body: JSON.stringify({
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "11111111-1111-4111-8111-111111111111",
  "content": {
    "title": "example",
    "text": "example",
    "source_url": null,
    "published_at": null,
    "language": null
  }
})
});
const result = await response.json();
// Check response.ok, the operation-specific body and completion state before continuing.
```

CLI

```bash
npx sosoapi api post /research-api/evidence/supply < request.json
```

虛構回應範例

```json
{
  "evidence": {
    "id": "11111111-1111-4111-8111-111111111111",
    "workspace_id": "11111111-1111-4111-8111-111111111111",
    "revision": 1,
    "title": null,
    "text": null,
    "source_category": "your_accounts",
    "platform": null,
    "source_url": null,
    "author": null,
    "language": null,
    "published_at": null,
    "retrieved_at": "2099-01-15T09:00:00Z",
    "valid_until": null,
    "availability": "available",
    "metrics": {
      "likes": null,
      "replies": null,
      "reposts": null,
      "views": null
    }
  }
}
```

## 相關工具及指南

MCP: sosoapi_research_evidence_supply

[API reference](https://sosoapi.ai/zh-hant/docs/api)
